diff -urN linux.store/linux/arch/arm/mm/fault.c linux/arch/arm/mm/fault.c
--- linux.store/linux/arch/arm/mm/fault.c	Sun Mar  3 13:08:26 1996
+++ linux/arch/arm/mm/fault.c	Sun Mar 10 14:34:32 1996
@@ -176,81 +176,79 @@
  */
 asmlinkage int do_dataabort (unsigned long min_addr, unsigned long max_addr, int mode, unsigned long *regs)
 {
-	unsigned long error_code;
-	int done = 0;
-	pte_t *pte;
+    unsigned long error_code;
+    int done = 0;
+    pte_t *pte;
 
-	IDEBUG(debug (min_addr, max_addr, mode, regs));
+    IDEBUG(debug (min_addr, max_addr, mode, regs));
 	
-	if ((min_addr >= LOGICAL_END || max_addr >= LOGICAL_END) && (mode & 3) == 0)
-	{
-		send_sig (SIGSEGV, current, 1);
-		return 1;
-	}
+    if ((min_addr >= LOGICAL_END || max_addr >= LOGICAL_END) && (mode & 3) == 0) {
+	send_sig (SIGSEGV, current, 1);
+	return 1;
+    }
 	
-	error_code = ((mode & 0x20) ? _PAGE_RW : 0) | ((mode & 3) ? 0 : _PAGE_USER);
+    error_code = ((mode & 0x20) ? _PAGE_RW : 0) | ((mode & 3) ? 0 : _PAGE_USER);
 
-	pte = pte_offset (pmd_offset (pgd_offset (current->mm, min_addr), min_addr), min_addr);
+    pte = pte_offset (pmd_offset (pgd_offset (current->mm, min_addr), min_addr), min_addr);
 
-	if (pte_present(*pte)) {
-		if ((error_code & _PAGE_USER) && !pte_read(*pte)) {
-			printk("Process (%s, %d) tried to access reserved mem %08lx mode %d (pc=%08lx, lr=%08lx)\n",
-				current->comm, current->pid, min_addr, mode, regs[15], regs[14]);
-			send_sig(SIGSEGV, current, 1);
-			return 1;
-		}
-
-		if ((mode & 0x700)==0x100 && pte_young(*pte)) {
-			printk("Page %08lx (%08lx) in but got abort (pc=%08lx) - undefined instr\n",
-				min_addr, pte_val(*pte), regs[15]);
-			return 0;
-		}
-
-		if (!pte_young (*pte)) {
-			*pte = pte_mkyoung (*pte);
-			done = 1;
-		}
-
-		if ((error_code & _PAGE_RW) && pte_write(*pte) && !pte_dirty (*pte)) {
-			*pte = pte_mkdirty (*pte);
-			done = 1;
-		}
-
-		if (done) {
-			invalidate ();
-			return 1;
-		}
+    if (pte_present(*pte)) {
+	if ((error_code & _PAGE_USER) && !pte_read(*pte)) {
+	    printk("Process (%s, %d) tried to access reserved mem %08lx mode %d (pc=%08lx, lr=%08lx)\n",
+			current->comm, current->pid, min_addr, mode, regs[15], regs[14]);
+	    send_sig(SIGSEGV, current, 1);
+	    return 1;
+	}
 
-		error_code |= _PAGE_PRESENT;
+	if ((mode & 0x700)==0x100 && pte_young(*pte)) {
+	    printk("Page %08lx (%08lx) in but got abort (pc=%08lx) - undefined instr\n",
+			min_addr, pte_val(*pte), regs[15]);
+	    return 0;
 	}
 
-	do_page_fault1(min_addr, error_code, (struct pt_regs *)regs);
+	if (!pte_young (*pte)) {
+	    *pte = pte_mkyoung (*pte);
+	   done = 1;
+	}
 
-	if ((min_addr ^ max_addr) >> PAGE_SHIFT) {
-		pte = pte_offset (pmd_offset (pgd_offset (current->mm, max_addr), max_addr), max_addr);
-		if (pte_present (*pte)) {
-			if (!pte_young (*pte)) {
-				*pte = pte_mkyoung (*pte);
-				done = 1;
-			}
-
-			if ((error_code & _PAGE_RW) && pte_write(*pte) && !pte_dirty (*pte)) {
-				*pte = pte_mkdirty (*pte);
-				done = 1;
-			}
-
-			if (done) {
-				invalidate ();
-				return 1;
-			}
-
-			error_code |= _PAGE_PRESENT;
-		}
-		else
-			error_code &= ~_PAGE_PRESENT;
-		do_page_fault1(max_addr, error_code, (struct pt_regs *)regs);
+	if ((error_code & _PAGE_RW) && pte_write(*pte) && !pte_dirty (*pte)) {
+	    *pte = pte_mkdirty (*pte);
+	    done = 1;
 	}
 
-	invalidate();
-	return 1;
+	if (done) {
+	    invalidate ();
+	    return 1;
+	}
+
+	error_code |= _PAGE_PRESENT;
+    }
+
+    do_page_fault1(min_addr, error_code, (struct pt_regs *)regs);
+
+    if ((min_addr ^ max_addr) >> PAGE_SHIFT) {
+	pte = pte_offset (pmd_offset (pgd_offset (current->mm, max_addr), max_addr), max_addr);
+	if (pte_present (*pte)) {
+	    if (!pte_young (*pte)) {
+		*pte = pte_mkyoung (*pte);
+		done = 1;
+	    }
+
+	    if ((error_code & _PAGE_RW) && pte_write(*pte) && !pte_dirty (*pte)) {
+		*pte = pte_mkdirty (*pte);
+		done = 1;
+	    }
+
+	    if (done) {
+		invalidate ();
+		return 1;
+	    }
+
+	    error_code |= _PAGE_PRESENT;
+	} else
+	    error_code &= ~_PAGE_PRESENT;
+	    do_page_fault1(max_addr, error_code, (struct pt_regs *)regs);
+    }
+
+    invalidate();
+    return 1;
 }
diff -urN linux.store/linux/arch/arm/mm/init.c linux/arch/arm/mm/init.c
--- linux.store/linux/arch/arm/mm/init.c	Sun Mar  3 13:08:36 1996
+++ linux/arch/arm/mm/init.c	Sun Mar 10 14:32:18 1996
@@ -27,8 +27,8 @@
 
 unsigned long low_memory;
 int page_nr    = 256;
-pgd_t swapper_pg_dir[1024];
 int page_shift = 15;
+pgd_t swapper_pg_dir[1024];
 
 extern void memfastset (void *, unsigned long n, size_t l);
 
@@ -45,58 +45,45 @@
  * ZERO_PAGE is a special page that is used for zero-initialized
  * data and COW.
  */
-#if 0
-pte_t * __bad_pagetable(void)
-{
-	extern char empty_bad_page_table[PAGE_SIZE];
-
-	__asm__ __volatile__("cld ; rep ; stosl":
-		:"a" (pte_val(BAD_PAGE)),
-		 "D" ((long) empty_bad_page_table),
-		 "c" (PAGE_SIZE/4)
-		:"di","cx");
-	return (pte_t *) empty_bad_page_table;
-}
-#endif
 char *empty_bad_page;
 pte_t __bad_page(void)
 {
-        memfastset(empty_bad_page, 0, PAGE_SIZE);
-	return pte_mkdirty(mk_pte((unsigned long) empty_bad_page, PAGE_SHARED));
+    memfastset(empty_bad_page, 0, PAGE_SIZE);
+    return pte_mkdirty(mk_pte((unsigned long) empty_bad_page, PAGE_SHARED));
 }
 
 char *empty_zero_page;
 unsigned long __zero_page(void)
 {
-        memfastset(empty_zero_page, 0, PAGE_SIZE);
-	return (unsigned long) empty_zero_page;
+    memfastset(empty_zero_page, 0, PAGE_SIZE);
+    return (unsigned long) empty_zero_page;
 }
 
 void show_mem(void)
 {
-	int i,free = 0,total = 0,reserved = 0;
-	int shared = 0;
+    int i,free = 0,total = 0,reserved = 0;
+    int shared = 0;
 
-	printk("Mem-info:\n");
-	show_free_areas();
-	printk("Free swap:       %6dkB\n",nr_swap_pages<<(PAGE_SHIFT-10));
-	i = (high_memory - PAGE_OFFSET) >> PAGE_SHIFT;
-	while (i-- > 0) {
-		total++;
-		if (mem_map[i].reserved)
-			reserved++;
-		else if (!mem_map[i].count)
-			free++;
-		else
-			shared += mem_map[i].count-1;
-	}
-	printk("%d pages of RAM\n",total);
-	printk("%d free pages\n",free);
-	printk("%d reserved pages\n",reserved);
-	printk("%d pages shared\n",shared);
-	show_buffers();
+    printk ("Mem-info:\n");
+    show_free_areas();
+    printk ("Free swap:       %6dkB\n",nr_swap_pages<<(PAGE_SHIFT-10));
+    i = (high_memory - PAGE_OFFSET) >> PAGE_SHIFT;
+    while (i-- > 0) {
+	total++;
+	if (mem_map[i].reserved)
+	    reserved++;
+	else if (!mem_map[i].count)
+	    free++;
+	else
+	    shared += mem_map[i].count-1;
+    }
+    printk("%d pages of RAM\n",total);
+    printk("%d free pages\n",free);
+    printk("%d reserved pages\n",reserved);
+    printk("%d pages shared\n",shared);
+    show_buffers();
 #ifdef CONFIG_NET
-	show_net_buffers();
+    show_net_buffers();
 #endif
 }
 
@@ -105,48 +92,38 @@
 unsigned long map_screen_mem(int log_start,int update)
 {
 	/* This routine needs more work to make it dynamically release/allocate mem! */
-	unsigned long address;
-	int i;
-	static int updated=0;
-#if 0
-	unsigned long screen_size = 256*1024;
-#else
-	unsigned long screen_size = 480*1024;
-#endif
-	pgd_t *pg_dir;
-	pmd_t *pm_dir;
-	pte_t *pt_entry;
-
-	if(updated)
-		return 0;
-
-	address=LOGICAL_END;
-
-	for(i = LOGICAL_END - screen_size; i<LOGICAL_END; i+=PAGE_SIZE)
-	{
-		pg_dir = swapper_pg_dir + (i >> PGDIR_SHIFT);
-		pm_dir = pmd_offset(pg_dir, i);
-		pt_entry = pte_offset(pm_dir, i);
-		if(i>=log_start)
-		{
-			*pt_entry = mk_pte(address, __pgprot(_PAGE_PRESENT|_PAGE_USER|_PAGE_RW|_PAGE_ACCESSED));
-			address+=PAGE_SIZE;
-		}
-		else
-			*pt_entry = mk_pte(0, __pgprot(0));
-	}
-	if(update)
-	{
-
-		for(; address<(LOGICAL_END + screen_size); address += PAGE_SIZE)
-		{
-			mem_map[MAP_NR(address)].count = 1;
-			free_page(address);
-		}
-		updated=1;
-		invalidate();
+    static int updated=0;
+    unsigned long screen_size = 480*1024;
+    unsigned long address;
+    int i;
+    pgd_t *pg_dir;
+    pmd_t *pm_dir;
+    pte_t *pt_entry;
+
+    if(updated)
+	return 0;
+
+    address = LOGICAL_END;
+
+    for (i = LOGICAL_END - screen_size; i < LOGICAL_END; i += PAGE_SIZE) {
+	pg_dir = swapper_pg_dir + (i >> PGDIR_SHIFT);
+	pm_dir = pmd_offset(pg_dir, i);
+	pt_entry = pte_offset(pm_dir, i);
+	if (i >= log_start) {
+	    *pt_entry = mk_pte(address, __pgprot(_PAGE_PRESENT|_PAGE_USER|_PAGE_RW|_PAGE_ACCESSED));
+	    address += PAGE_SIZE;
+	} else
+	    *pt_entry = mk_pte(0, __pgprot(0));
+    }
+    if (update) {
+	for (; address<(LOGICAL_END + screen_size); address += PAGE_SIZE) {
+	    mem_map[MAP_NR(address)].count = 1;
+	    free_page(address);
 	}
-	return address;
+	updated=1;
+	invalidate();
+    }
+    return address;
 }
 
 /*
@@ -158,129 +135,122 @@
  */
 unsigned long paging_init(unsigned long start_mem, unsigned long end_mem)
 {
-	extern int page_nr;
-	int address;
-	int i;
-	pgd_t *pg_dir;
-	pmd_t *pm_dir;
-	pte_t *pt_entry;
-
-	page_nr = MAP_NR(end_mem);
-/* We appear to need this */
-	current = &init_task;
+    extern int page_nr;
+    int address;
+    int i;
+    pgd_t *pg_dir;
+    pmd_t *pm_dir;
+    pte_t *pt_entry;
+
+    page_nr = MAP_NR(end_mem);
+    /*
+     * We appear to need this
+     */
+    current = &init_task;
 	
-	pg_dir = swapper_pg_dir;
-	pm_dir = pmd_offset(pg_dir, 0);
-	pt_entry = pte_offset(pm_dir, 0);
-
-	/* Insert mappings for the screen memory */
-	for(i=0; i<LOGICAL_END; i+=PAGE_SIZE)
-	{
-		pt_entry[i>>PAGE_SHIFT] = mk_pte(0, __pgprot(0));
-	}
-#if 0
-	address = map_screen_mem(0x02000000 - 256*1024, 0);
-#else
-	address = map_screen_mem(LOGICAL_END - 480*1024, 0);
-#endif
-
-	/* Allocate zero page */
-	for(i=0; i<32768>>PAGE_SHIFT; i++)
-	{
-		pt_entry[i] = mk_pte(address, PAGE_READONLY);
-		address += PAGE_SIZE;
-	}
-
-	/* Allocate kernel code pages */
-	for(i=0x01800000>>PAGE_SHIFT; address < start_mem; i++)
-	{
-		pt_entry[i] = mk_pte(address, PAGE_SHARED);
-		address += PAGE_SIZE;
-	}
-
-	empty_bad_page = (unsigned char *)address;
+    pg_dir = swapper_pg_dir;
+    pm_dir = pmd_offset(pg_dir, 0);
+    pt_entry = pte_offset(pm_dir, 0);
+
+    /* Insert mappings for the screen memory */
+    for(i=0; i<LOGICAL_END; i+=PAGE_SIZE)
+	pt_entry[i>>PAGE_SHIFT] = mk_pte(0, __pgprot(0));
+
+    address = map_screen_mem(LOGICAL_END - 480*1024, 0);
+
+    /* Allocate zero page */
+    for (i = 0; i < 32768 >> PAGE_SHIFT; i++) {
+	pt_entry[i] = mk_pte(address, PAGE_READONLY);
 	address += PAGE_SIZE;
-	empty_zero_page = (unsigned char *)address;
+    }
+
+    /* Allocate kernel code pages */
+    for (i = 0x01800000 >> PAGE_SHIFT; address < start_mem; i++) {
+	pt_entry[i] = mk_pte(address, PAGE_SHARED);
 	address += PAGE_SIZE;
+    }
 
-	invalidate();
-	return free_area_init(address, end_mem);
+    empty_bad_page = (unsigned char *)address;
+    address += PAGE_SIZE;
+    empty_zero_page = (unsigned char *)address;
+    address += PAGE_SIZE;
+
+    invalidate();
+    return free_area_init(address, end_mem);
 }
 
 void mem_init(unsigned long start_mem, unsigned long end_mem)
 {
-	int codepages = 0;
-	int reservedpages = 0;
-	int datapages = 0;
-	unsigned long tmp;
-	extern int etext;
-	int i;
-	extern void sound_init(void);
-
-	end_mem &= PAGE_MASK;
-	high_memory = end_mem;
-
-	/* mark usable pages in the mem_map[] */
-	start_mem = PAGE_ALIGN(start_mem);
-
-	for(i=0; i<MAP_NR(start_mem); i++)
-	{
-		mem_map[i].reserved = 1;
-		mem_map[i].count = 0;
-	}
-
-	while(i < MAP_NR(end_mem))
-	{
-		mem_map[i].reserved = 0;
-		mem_map[i++].count = 0;
-	}
+    int codepages = 0;
+    int reservedpages = 0;
+    int datapages = 0;
+    unsigned long tmp;
+    extern int etext;
+    int i;
+    extern void sound_init(void);
+
+    end_mem &= PAGE_MASK;
+    high_memory = end_mem;
+
+    /* mark usable pages in the mem_map[] */
+    start_mem = PAGE_ALIGN(start_mem);
+
+    for (i = 0; i < MAP_NR(start_mem); i++) {
+	mem_map[i].reserved = 1;
+	mem_map[i].count = 0;
+    }
+
+    while (i < MAP_NR(end_mem)) {
+	mem_map[i].reserved = 0;
+	mem_map[i++].count = 0;
+    }
 
 #ifdef CONFIG_SCSI
-	scsi_mem_init(high_memory);
+    scsi_mem_init(high_memory);
 #endif
-	for (tmp = LOGICAL_END ; tmp < high_memory ; tmp += PAGE_SIZE) {
-		if (mem_map[MAP_NR(tmp)].reserved) {
-			if (tmp < LOGICAL_END + (256*1024+32*1024))
-				reservedpages++;
-			else if (tmp < ((unsigned long) &etext - 0x01800000 + 0x02048000))
-				codepages++;
-			else
-				datapages++;
-			continue;
-		}
-		mem_map[MAP_NR(tmp)].count = 1;
-		free_page(tmp);
-	}
-	tmp = nr_free_pages << PAGE_SHIFT;
-	printk("Memory: %luk/%luk available (%dk kernel code, %dk reserved, %dk data)\n",
-		tmp >> 10,
-		(high_memory - LOGICAL_END) >> 10,
-		codepages << (PAGE_SHIFT-10),
-		reservedpages << (PAGE_SHIFT-10),
-		datapages << (PAGE_SHIFT-10));
+    for (tmp = LOGICAL_END ; tmp < high_memory ; tmp += PAGE_SIZE) {
+	if (mem_map[MAP_NR(tmp)].reserved) {
+	    if (tmp < LOGICAL_END + (256*1024+32*1024))
+		reservedpages++;
+	    else if (tmp < ((unsigned long) &etext - 0x01800000 + 0x02048000))
+		codepages++;
+	    else
+		datapages++;
+	    continue;
+	}
+	mem_map[MAP_NR(tmp)].count = 1;
+	free_page(tmp);
+    }
+    tmp = nr_free_pages << PAGE_SHIFT;
+    printk ("Memory: %luk/%luk available (%dk kernel code, %dk reserved, %dk data)\n",
+	tmp >> 10,
+	(high_memory - LOGICAL_END) >> 10,
+	codepages << (PAGE_SHIFT-10),
+	reservedpages << (PAGE_SHIFT-10),
+	datapages << (PAGE_SHIFT-10));
 #ifdef CONFIG_SOUND
-	sound_init();
+    sound_init();
 #endif
 }
 
 void si_meminfo(struct sysinfo *val)
 {
-	int i;
+    int i;
 
-	i = MAP_NR(high_memory);
-	val->totalram = 0;
-	val->sharedram = 0;
-	val->freeram = nr_free_pages << PAGE_SHIFT;
-	val->bufferram = buffermem;
-	while (i-- > 0)  {
-		if (mem_map[i].reserved)
-			continue;
-		val->totalram++;
-		if (!mem_map[i].count)
-			continue;
-		val->sharedram += mem_map[i].count-1;
-	}
-	val->totalram <<= PAGE_SHIFT;
-	val->sharedram <<= PAGE_SHIFT;
-	return;
+    i = MAP_NR(high_memory);
+    val->totalram = 0;
+    val->sharedram = 0;
+    val->freeram = nr_free_pages << PAGE_SHIFT;
+    val->bufferram = buffermem;
+    while (i-- > 0)  {
+	if (mem_map[i].reserved)
+	    continue;
+	val->totalram++;
+	if (!mem_map[i].count)
+	    continue;
+	val->sharedram += mem_map[i].count-1;
+    }
+    val->totalram <<= PAGE_SHIFT;
+    val->sharedram <<= PAGE_SHIFT;
+    return;
 }
diff -urN linux.store/linux/include/asm-arm/a.out.h linux/include/asm-arm/a.out.h
--- linux.store/linux/include/asm-arm/a.out.h	Sun Feb 11 09:32:54 1996
+++ linux/include/asm-arm/a.out.h	Sun Feb 11 09:32:54 1996
@@ -13,18 +13,11 @@
   unsigned a_drsize;		/* length of relocation info for data, in bytes */
 };
 
-#define N_TXTADDR(a)	0x8000
-
 #define N_TRSIZE(a)	((a).a_trsize)
 #define N_DRSIZE(a)	((a).a_drsize)
 #define N_SYMSIZE(a)	((a).a_syms)
 
 #define M_ARM 103
 
-#ifdef __KERNEL__
-
-#define STACK_TOP	24*1024*1024
-
-#endif
-
+#include <asm/arch/a.out.h>
 #endif /* __A_OUT_GNU_H__ */
diff -urN linux.store/linux/include/asm-arm/arch-a5k/a.out.h linux/include/asm-arm/arch-a5k/a.out.h
--- linux.store/linux/include/asm-arm/arch-a5k/a.out.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-a5k/a.out.h	Sun Feb 11 09:32:54 1996
@@ -0,0 +1,17 @@
+/*
+ * linux/include/asm-arm/arch-a5k/a.out.h
+ *
+ * Copyright (C) 1996 Russell King
+ */
+
+#ifndef __ASM_ARCH_A_OUT_H
+#define __ASM_ARCH_A_OUT_H
+
+#define N_TXTADDR(a)	0x8000
+
+#ifdef __KERNEL__
+#define STACK_TOP	24*1024*1024
+#endif
+
+#endif
+
diff -urN linux.store/linux/include/asm-arm/arch-a5k/dma.h linux/include/asm-arm/arch-a5k/dma.h
--- linux.store/linux/include/asm-arm/arch-a5k/dma.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-a5k/dma.h	Wed Mar 13 15:21:00 1996
@@ -0,0 +1,64 @@
+#ifndef __ASM_ARCH_DMA_H
+#define __ASM_ARCH_DMA_H
+
+/* enable/disable a specific DMA channel */
+extern void enable_dma(unsigned int dmanr);
+
+static __inline__ void disable_dma(unsigned int dmanr)
+{
+    switch(dmanr) {
+	case 2:  disable_irq(16); break;
+	default: printk("disable_dma: dma %d not supported\n", dmanr); break;
+    }
+}
+
+/* Clear the 'DMA Pointer Flip Flop'.
+ * Write 0 for LSB/MSB, 1 for MSB/LSB access.
+ * Use this once to initialize the FF to a known state.
+ * After that, keep track of it. :-)
+ * --- In order to do that, the DMA routines below should ---
+ * --- only be used while interrupts are disabled! ---
+ */
+static __inline__ void clear_dma_ff(unsigned int dmanr)
+{
+    switch(dmanr) {
+	case 2:  break;
+	default: printk("clear_dma_ff: dma %d not supported\n", dmanr); break;
+    }
+}
+
+/* set mode (above) for a specific DMA channel */
+extern void set_dma_mode(unsigned int dmanr, char mode);
+
+/* Set only the page register bits of the transfer address.
+ * This is used for successive transfers when we know the contents of
+ * the lower 16 bits of the DMA current address register, but a 64k boundary
+ * may have been crossed.
+ */
+static __inline__ void set_dma_page(unsigned int dmanr, char pagenr)
+{
+    printk("set_dma_page: dma %d not supported\n", dmanr);
+}
+
+
+/* Set transfer address & page bits for specific DMA channel.
+ * Assumes dma flipflop is clear.
+ */
+extern void set_dma_addr(unsigned int dmanr, unsigned int addr);
+
+/* Set transfer size for a specific DMA channel.
+ */
+extern void set_dma_count(unsigned int dmanr, unsigned int count);
+
+/* Get DMA residue count. After a DMA transfer, this
+ * should return zero. Reading this while a DMA transfer is
+ * still in progress will return unpredictable results.
+ * If called before the channel has been used, it may return 1.
+ * Otherwise, it returns the number of _bytes_ left to transfer.
+ *
+ * Assumes DMA flip-flop is clear.
+ */
+extern int get_dma_residue(unsigned int dmanr);
+
+#endif /* _ASM_ARCH_DMA_H */
+
diff -urN linux.store/linux/include/asm-arm/arch-a5k/irqs.h linux/include/asm-arm/arch-a5k/irqs.h
--- linux.store/linux/include/asm-arm/arch-a5k/irqs.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-a5k/irqs.h	Sun Feb 11 09:32:54 1996
@@ -0,0 +1,28 @@
+/*
+ * linux/include/asm-arm/arch-a5k/irqs.h
+ *
+ * Copyright (C) 1996 Russell King
+ */
+
+#define IRQ_PRINTER		0
+#define IRQ_BATLOW		1
+#define IRQ_FLOPPYINDEX		2
+#define IRQ_VSYNCPULSE		3
+#define IRQ_POWERON		4
+#define IRQ_TIMER0		5
+#define IRQ_TIMER1		6
+#define IRQ_IMMEDIATE		7
+#define IRQ_EXPCARDFIQ		8
+#define IRQ_SOUNDCHANGE		9
+#define IRQ_SERIALPORT		10
+#define IRQ_HARDDISK		11
+#define IRQ_FLOPPYDISK		12
+#define IRQ_EXPANSIONCARD	13
+#define IRQ_KEYBOARDTX		14
+#define IRQ_KEYBOARDRX		15
+
+#define FIQ_FLOPPYDATA		0
+#define FIQ_ECONET		2
+#define FIQ_SERIALPORT		4
+#define FIQ_EXPANSIONCARD	6
+#define FIQ_FORCE		7
diff -urN linux.store/linux/include/asm-arm/arch-a5k/oldlatches.h linux/include/asm-arm/arch-a5k/oldlatches.h
--- linux.store/linux/include/asm-arm/arch-a5k/oldlatches.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-a5k/oldlatches.h	Sun Feb 11 09:32:54 1996
@@ -0,0 +1,9 @@
+/*
+ * Dummy oldlatches.h
+ *
+ * Copyright (C) 1996 Russell King
+ */
+
+#ifdef __need_oldlatches
+#error "Old latches not present in this (a5k) machine"
+#endif
diff -urN linux.store/linux/include/asm-arm/arch-arc/a.out.h linux/include/asm-arm/arch-arc/a.out.h
--- linux.store/linux/include/asm-arm/arch-arc/a.out.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-arc/a.out.h	Sun Feb 11 09:32:57 1996
@@ -0,0 +1,17 @@
+/*
+ * linux/include/asm-arm/arch-arc/a.out.h
+ *
+ * Copyright (C) 1996 Russell King
+ */
+
+#ifndef __ASM_ARCH_A_OUT_H
+#define __ASM_ARCH_A_OUT_H
+
+#define N_TXTADDR(a)	0x8000
+
+#ifdef __KERNEL__
+#define STACK_TOP	24*1024*1024
+#endif
+
+#endif
+
diff -urN linux.store/linux/include/asm-arm/arch-arc/dma.h linux/include/asm-arm/arch-arc/dma.h
--- linux.store/linux/include/asm-arm/arch-arc/dma.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-arc/dma.h	Wed Mar 13 15:20:23 1996
@@ -0,0 +1,81 @@
+#ifndef __ASM_ARCH_DMA_H
+#define __ASM_ARCH_DMA_H
+
+/* enable/disable a specific DMA channel */
+extern void enable_dma(unsigned int dmanr);
+
+static __inline__ void disable_dma(unsigned int dmanr)
+{
+    switch(dmanr) {
+#ifdef CONFIG_BLK_DEV_FD
+    /* This is a HACK - at the moment ARM Linux doesn't support two FIQs
+     being serviced together, until it does this hack must stay - DAG */
+	case 0: { /* Data DMA */
+    /* We have to replace it by FIQ code for command end */
+    unsigned long flags;
+    extern void fdc1772_comendhandler(void);
+    /*printk("disable_dma for FD1772\n");*/
+    disable_irq(16);
+
+    save_flags(flags);
+    cliIF();
+    *((unsigned int *)0x1c)=0xea000000 | (((unsigned int)fdc1772_comendhandler-(0x1c+8))/4); /* B fdc1772_comendhandler */ 
+    restore_flags(flags);
+  }
+  break;
+
+#endif
+	default: printk("disable_dma: dma %d not supported\n", dmanr); break;
+    }
+}
+
+/* Clear the 'DMA Pointer Flip Flop'.
+ * Write 0 for LSB/MSB, 1 for MSB/LSB access.
+ * Use this once to initialize the FF to a known state.
+ * After that, keep track of it. :-)
+ * --- In order to do that, the DMA routines below should ---
+ * --- only be used while interrupts are disabled! ---
+ */
+static __inline__ void clear_dma_ff(unsigned int dmanr)
+{
+    switch(dmanr) {
+	case 2:  break;
+	default: printk("clear_dma_ff: dma %d not supported\n", dmanr); break;
+    }
+}
+
+/* set mode (above) for a specific DMA channel */
+extern void set_dma_mode(unsigned int dmanr, char mode);
+
+/* Set only the page register bits of the transfer address.
+ * This is used for successive transfers when we know the contents of
+ * the lower 16 bits of the DMA current address register, but a 64k boundary
+ * may have been crossed.
+ */
+static __inline__ void set_dma_page(unsigned int dmanr, char pagenr)
+{
+    printk("set_dma_page: dma %d not supported\n", dmanr);
+}
+
+
+/* Set transfer address & page bits for specific DMA channel.
+ * Assumes dma flipflop is clear.
+ */
+extern void set_dma_addr(unsigned int dmanr, unsigned int addr);
+
+/* Set transfer size for a specific DMA channel.
+ */
+extern void set_dma_count(unsigned int dmanr, unsigned int count);
+
+/* Get DMA residue count. After a DMA transfer, this
+ * should return zero. Reading this while a DMA transfer is
+ * still in progress will return unpredictable results.
+ * If called before the channel has been used, it may return 1.
+ * Otherwise, it returns the number of _bytes_ left to transfer.
+ *
+ * Assumes DMA flip-flop is clear.
+ */
+extern int get_dma_residue(unsigned int dmanr);
+
+#endif /* _ASM_ARCH_DMA_H */
+
diff -urN linux.store/linux/include/asm-arm/arch-arc/irqs.h linux/include/asm-arm/arch-arc/irqs.h
--- linux.store/linux/include/asm-arm/arch-arc/irqs.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-arc/irqs.h	Sun Feb 11 09:32:57 1996
@@ -0,0 +1,30 @@
+/*
+ * linux/include/asm-arm/arch-arc/irqs.h
+ *
+ * Copyright (C) 1996 Russell King, Dave Gilbert (gilbertd@cs.man.ac.uk)
+ */
+
+#define IRQ_PRINTERBUSY		0
+#define IRQ_SERIALRING		1
+#define IRQ_PRINTERACK		2
+#define IRQ_VSYNCPULSE		3
+#define IRQ_POWERON		4
+#define IRQ_TIMER0		5
+#define IRQ_TIMER1		6
+#define IRQ_IMMEDIATE		7
+#define IRQ_EXPCARDFIQ		8
+#define IRQ_SOUNDCHANGE		9
+#define IRQ_SERIALPORT		10
+#define IRQ_HARDDISK		11
+#define IRQ_FLOPPYCHANGED	12
+#define IRQ_EXPANSIONCARD	13
+#define IRQ_KEYBOARDTX		14
+#define IRQ_KEYBOARDRX		15
+
+#define FIQ_FLOPPYDATA		0
+#define FIQ_FLOPPYIRQ		1
+#define FIQ_ECONET		2
+#define FIQ_EXPANSIONCARD	6
+#define FIQ_FORCE		7
+
+#define FIQ_FD1772		FIQ_FLOPPYIRQ
diff -urN linux.store/linux/include/asm-arm/arch-arc/oldlatches.h linux/include/asm-arm/arch-arc/oldlatches.h
--- linux.store/linux/include/asm-arm/arch-arc/oldlatches.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-arc/oldlatches.h	Sun Feb 11 09:32:57 1996
@@ -0,0 +1,24 @@
+#ifndef _ASM_ARM_ARCHARC_OLDLATCH_H
+#define _ASN_ARM_ARCHARC_OLDLATCH_H
+
+#define LATCHA_FDSEL0    (1<<0)
+#define LATCHA_FDSEL1    (1<<1)
+#define LATCHA_FDSEL2    (1<<2)
+#define LATCHA_FDSEL3    (1<<3)
+#define LATCHA_FDSELALL  (0xf)
+#define LATCHA_SIDESEL   (1<<4)
+#define LATCHA_MOTOR     (1<<5)
+#define LATCHA_INUSE     (1<<6)
+#define LATCHA_CHANGERST (1<<7)
+
+#define LATCHB_FDCDENSITY  (1<<1)
+#define LATCHB_FDCRESET    (1<<3)
+#define LATCHB_PRINTSTROBE (1<<4)
+
+/* newval=(oldval & mask)|newdata */
+void oldlatch_bupdate(unsigned char mask,unsigned char newdata);
+
+/* newval=(oldval & mask)|newdata */
+void oldlatch_aupdate(unsigned char mask,unsigned char newdata);
+
+#endif
diff -urN linux.store/linux/include/asm-arm/arch-arc/system.h linux/include/asm-arm/arch-arc/system.h
--- linux.store/linux/include/asm-arm/arch-arc/system.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-arc/system.h	Wed Mar 13 15:10:27 1996
@@ -0,0 +1,9 @@
+#define cliIF()				\
+	do {				\
+	  unsigned long temp;		\
+	  __asm__ __volatile__(		\
+"	mov	%0, pc\n"		\
+"	orr %0, %0, #0x0c000000\n"	\
+"	teqp	%0, #0\n"		\
+	  : "=r" (temp));
+
diff -urN linux.store/linux/include/asm-arm/arch-rpc/oldlatches.h linux/include/asm-arm/arch-rpc/oldlatches.h
--- linux.store/linux/include/asm-arm/arch-rpc/oldlatches.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/arch-rpc/oldlatches.h	Tue Mar 12 15:36:14 1996
@@ -0,0 +1,9 @@
+/*
+ * Dummy oldlatches.h
+ *
+ * Copyright (C) 1996 Russell King
+ */
+
+#ifdef __need_oldlatches
+#error "Old latches not present in this (rpc) machine"
+#endif
diff -urN linux.store/linux/include/asm-arm/assembler.h linux/include/asm-arm/assembler.h
--- linux.store/linux/include/asm-arm/assembler.h	Sun Feb 11 09:32:54 1996
+++ linux/include/asm-arm/assembler.h	Sun Feb 11 09:32:54 1996
@@ -2,50 +2,12 @@
  * linux/asm/assembler.h
  *
  * This file contains arm architecture specific defines
- * for the different processors
+ * for the different processors.
+ *
+ * Do not include any C declarations in this file - it is included by
+ * assembler source.
  */
 
-#if !defined (__arm2__) && !defined (__arm3__) && !defined (__arm6__)
-#error "Only ARN2, ARM3 and ARM6 architectures are supported"
-#endif
-
-#undef __FOUND
-#undef __ERROR
-
-#ifdef __arm2__
-#ifdef __FOUND
-#undef __ERROR
-#define __ERROR
-#else
-#define __FOUND
-#endif
-#endif
-
-#ifdef __arm3__
-#ifdef __FOUND
-#undef __ERROR
-#define __ERROR
-#else
-#define __FOUND
-#endif
-#endif
-
-#ifdef __arm6__
-#ifdef __FOUND
-#undef __ERROR
-#define __ERROR
-#else
-#define __FOUND
-#endif
-#endif
-
-#ifdef __ERROR
-#error "Only one of __arm3__ and __arm6__ may be defined"
-#endif
-
-#undef __FOUND
-#undef __ERROR
-
 /*
  * LOADREGS: multiple register load (ldm) with pc in register list
  *		(takes account of ARM6 not using ^)
@@ -69,73 +31,4 @@
  * SVCMODE: switch to SVC mode
  */
 
-#if defined (__arm2__)
-#define LOADREGS(cond, base, reglist...)\
-	ldm##cond	base,reglist^
-
-#define RETINSTR(instr, regs...)\
-	instr##s	regs
-
-#define MODENOP\
-	mov	r0, r0
-
-#define SAVEIRQS
-#define RESTOREIRQS
-
-#define DISABLEIRQS\
-	teqp	pc, #0x08000003
-
-#define ENABLEIRQS\
-	teqp	pc, #0x00000003
-
-#define USERMODE\
-	teqp	pc, #0x00000000;\
-	mov	r0, r0
-
-#define SVCMODE\
-	teqp	pc, #0x00000003;\
-	mov	r0, r0
-#endif
-
-#if defined (__arm3__)
-#define LOADREGS(cond, base, reglist...)\
-	ldm##cond	base,reglist^
-
-#define RETINSTR(instr, regs...)\
-	instr##s	regs
-
-#define MODENOP
-
-#define SAVEIRQS
-#define RESTOREIRQS
-
-#define DISABLEIRQS\
-	teqp	pc, #0x08000003
-
-#define ENABLEIRQS\
-	teqp	pc, #0x00000003
-
-#define USERMODE\
-	teqp	pc, #0x00000000
-
-#define SVCMODE\
-	teqp	pc, #0x00000003
-#endif
-
-#if defined (__arm6__)
-#define LOADREGS(cond, base, reglist...)\
-	ldm##cond	base,reglist
-
-#define RETINSTR(instr, regs...)\
-	instr	regs
-
-#define MODENOP
-
-#define SAVEIRQS
-#define RESTOREIRQS
-
-#define DISABLEIRQS
-#define ENABLEIRQS
-#define USERMODE
-#define SVCMODE
-#endif
+#include <asm/proc/assembler.h>
diff -urN linux.store/linux/include/asm-arm/bugs.h linux/include/asm-arm/bugs.h
--- linux.store/linux/include/asm-arm/bugs.h	Sun Feb 11 09:32:54 1996
+++ linux/include/asm-arm/bugs.h	Sun Feb 11 09:32:54 1996
@@ -4,14 +4,4 @@
  *  Copyright (C) 1995  Russell King
  */
 
-/*
- * This is included by init/main.c to check for architecture-dependent bugs.
- *
- * Needs:
- *      void check_bugs(void);
- */
-         
-static inline void check_bugs(void)
-{
-}
-
+#include <asm/proc/bugs.h>
diff -urN linux.store/linux/include/asm-arm/dma.h linux/include/asm-arm/dma.h
--- linux.store/linux/include/asm-arm/dma.h	Sun Feb 11 09:32:54 1996
+++ linux/include/asm-arm/dma.h	Wed Mar 13 15:18:17 1996
@@ -10,64 +10,7 @@
 #define DMA_MODE_READ		0x44
 #define DMA_MODE_WRITE		0x48
 
-/* enable/disable a specific DMA channel */
-extern void enable_dma(unsigned int dmanr);
-
-static __inline__ void disable_dma(unsigned int dmanr)
-{
-    switch(dmanr) {
-	case 2:  disable_irq(16); break;
-	default: printk("disable_dma: dma %d not supported\n", dmanr); break;
-    }
-}
-
-/* Clear the 'DMA Pointer Flip Flop'.
- * Write 0 for LSB/MSB, 1 for MSB/LSB access.
- * Use this once to initialize the FF to a known state.
- * After that, keep track of it. :-)
- * --- In order to do that, the DMA routines below should ---
- * --- only be used while interrupts are disabled! ---
- */
-static __inline__ void clear_dma_ff(unsigned int dmanr)
-{
-    switch(dmanr) {
-	case 2:  break;
-	default: printk("clear_dma_ff: dma %d not supported\n", dmanr); break;
-    }
-}
-
-/* set mode (above) for a specific DMA channel */
-extern void set_dma_mode(unsigned int dmanr, char mode);
-
-/* Set only the page register bits of the transfer address.
- * This is used for successive transfers when we know the contents of
- * the lower 16 bits of the DMA current address register, but a 64k boundary
- * may have been crossed.
- */
-static __inline__ void set_dma_page(unsigned int dmanr, char pagenr)
-{
-    printk("set_dma_page: dma %d not supported\n", dmanr);
-}
-
-
-/* Set transfer address & page bits for specific DMA channel.
- * Assumes dma flipflop is clear.
- */
-extern void set_dma_addr(unsigned int dmanr, unsigned int addr);
-
-/* Set transfer size for a specific DMA channel.
- */
-extern void set_dma_count(unsigned int dmanr, unsigned int count);
-
-/* Get DMA residue count. After a DMA transfer, this
- * should return zero. Reading this while a DMA transfer is
- * still in progress will return unpredictable results.
- * If called before the channel has been used, it may return 1.
- * Otherwise, it returns the number of _bytes_ left to transfer.
- *
- * Assumes DMA flip-flop is clear.
- */
-extern int get_dma_residue(unsigned int dmanr);
+#include <asm/arch/dma.h>
 
 /* These are in kernel/dma.c: */
 extern int request_dma(unsigned int dmanr, const char * device_id);   /* reserve a DMA channel */
diff -urN linux.store/linux/include/asm-arm/irq-no.h linux/include/asm-arm/irq-no.h
--- linux.store/linux/include/asm-arm/irq-no.h	Sun Feb 11 09:32:55 1996
+++ linux/include/asm-arm/irq-no.h	Wed Mar 13 15:28:12 1996
@@ -1,25 +1,11 @@
-#define IRQ_PRINTERBUSY		0
-#define IRQ_SERIALRING		1
-#define IRQ_PRINTERACK		2
-#define IRQ_VSYNCPULSE		3
-#define IRQ_POWERON		4
-#define IRQ_TIMER0		5
-#define IRQ_TIMER1		6
-#define IRQ_7			7
-#define IRQ_8			8
-#define IRQ_SOUNDCHANGE		9
-#define IRQ_SERIALPORT		10
-#define IRQ_HARDDISK		11
-#define IRQ_FLOPPYDISK		12
-#define IRQ_EXPANSIONCARD	13
-#define IRQ_KEYBOARDTX		14
-#define IRQ_KEYBOARDRX		15
+/*
+ * linux/include/asm-arm/irq-no.h
+ *
+ * Machine independent interrupt numbers
+ */
 
-#define FIQ_FLOPPYDATA		0
-#define FIQ_ECONET		2
-#define FIQ_EXPANSIONCARD	6
-
-#define TIMER_IRQ		IRQ_TIMER0
-
-#define NUM_IRQS		32
+#include <asm/arch/irqs.h>
 
+#ifndef NR_IRQS
+#define NR_IRQS		32
+#endif
